<template>
    <div class="submit">
        <div class="page-top">
            <div class="pageTitle">赠送作品</div>
            <div class="product">
                <van-image width="80" height="80" :radius="6" :src="getImg(changeImgs(info.pic))" fit="cover" />
                <div class="product-content">
                    <div class="text1 van-multi-ellipsis--l2">
                        {{ info.name }}
                    </div>
                    <div class="text" v-if="info.number">编号:{{ info.number }}</div>
                    <div class="no"></div>

                    <div class="price">¥{{ info.price }}</div>
                </div>
            </div>
        </div>
        <driver />
        <div class="input">
            <div class="text1">请输入交易密码，验证信息</div>
            <div v-if="sets">
                <van-password-input :value="password" :focused="showKeyboard" @focus="showKeyboard = true" />
                <!-- 数字键盘 -->
                <van-number-keyboard
                    v-model="password"
                    :show="showKeyboard"
                    @blur="showKeyboard = false"
                    maxlength="6"
                />
                <div class="text2" @click="$router.push('/tradingPassword')">忘记密码？</div>
            </div>
            <div v-else class="text3" @click="$router.push('/tradingPassword')">您当前没有交易密码，点击去设置</div>
        </div>
        <driver />
        <div class="list">
            <div class="info">
                <div class="text1">GAS费用</div>
                <div class="text2">¥{{ gas }}</div>
            </div>

            <div class="pay">
                <div class="pay-item" @click="payType = item.type" v-for="(item, index) in payInfos" :key="index">
                    <img :src="item.icon" alt="" />
                    <span>{{ item.name }}</span>
                    <img class="choose" :src="payType === item.type ? icons[1] : icons[0]" alt="" />
                </div>
            </div>
        </div>

        <div class="bottom van-safe-area-bottom" ref="bottom">
            <div class="bottom-content">
                <div class="btn1" @click="$router.go(-1)">
                    取消
                    <!-- <van-button @click="submit" :disabled="orderId"> 取消 </van-button> -->
                </div>
                <div class="btn2" @click="submit">支付GAS费</div>
                <a id="pay" :href="hrefUrl"></a>
            </div>
        </div>
    </div>
</template>

<script>
import resolveUrl from 'resolve-url';
import { add } from 'mathjs';
import { mapState } from 'vuex';
import product from '../mixins/product';
// import Driver from '../components/Driver.vue';
let inWeixin = /micromessenger/i.test(navigator.userAgent);
let inApp = /#cordova#/i.test(navigator.userAgent);
export default {
    name: 'Submit',
    mixins: [product],
    data() {
        return {
            info: {},
            message: '',
            password: '',
            enable_wx_lite: false,
            enable_wx_pub: false,
            payType: inWeixin ? 'WEIXIN' : 'ALIPAY',
            // payType: 'ALIPAY',
            payInfos: [
                {
                    icon: require('@assets/svgs/zhifubao.svg'),
                    name: '支付宝',
                    type: 'ALIPAY'
                },
                {
                    icon: require('@assets/svgs/wechat.svg'),
                    name: '微信',
                    type: 'WEIXIN'
                }
                // {
                //   icon: require("@assets/svgs/png-decp.svg"),
                //   name: "DCEP",
                // },
            ],
            icons: [require('@assets/icon_gouxuan_huise.png'), require('@assets/icon_gouxuan_pre.png')],
            bottom: null,
            orderId: 0,
            gas: 1,
            showKeyboard: false,
            hrefUrl: '',
            inWeixin,
            inApp,
            timer: null
        };
    },
    computed: {
        ...mapState(['userInfo']),
        money() {
            if (this.info.price) {
                return add(this.info.price, this.gas);
            } else {
                return 0;
            }
        }
    },
    mounted() {
        this.passFn();
        this.$toast.loading({
            message: '加载中...',
            forbidClick: true
        });
        if (this.$route.query.id) {
            this.$http.get('/asset/get/' + this.$route.query.id).then(res => {
                this.info = res;
                this.$toast.clear();
                console.log(this.info);
            });
        }

        Promise.all([
            this.$http.get('/sysConfig/get/gas_fee').then(res => {
                this.gas = res.value;
                return Promise.resolve();
            }),
            inWeixin
                ? this.$http.get('/sysConfig/get/enable_wx_pub').then(res => {
                      this.enable_wx_pub = res.value === '1';
                      return Promise.resolve();
                  })
                : Promise.resolve(),
            this.$http.get('/sysConfig/get/enable_wx_lite').then(res => {
                this.enable_wx_lite = res.value === '1';
                return Promise.resolve();
            })
        ]).then(() => {
            if (!(this.enable_wx_lite || this.enable_wx_pub)) {
                this.payInfos.splice(1, 1);
                this.payType = 'ALIPAY';
            } else if (this.enable_wx_pub) {
                this.payChannel = 'wx_pub';
            } else {
                this.payChannel = 'wx_lite';
            }
        });
    },
    methods: {
        passFn() {
            this.$http
                .get('/user/tradeCodeStatus', {
                    userId: this.userInfo.id
                })
                .then(res => {
                    console.log(res);
                    this.sets = res.set;
                });
        },
        getOrder(next = false) {
            this.$http.get('/giftOrder/get/' + this.orderId).then(res => {
                if (this.timer) {
                    clearTimeout(this.timer);
                }
                if (res.status === 'PROCESSING' || res.status === 'FINISH' || res.status === 'CANCELLED') {
                    this.$dialog
                        .alert({
                            title: '提示',
                            message: res.status === 'CANCELLED' ? '藏品转赠失败' : '藏品转赠成功'
                        })
                        .then(() => {
                            if (res.status === 'CANCELLED') {
                                this.$router.go(-2);
                            } else {
                                this.$router.go(-2);
                            }
                            // on close
                        });
                } else if (next) {
                    this.timer = setTimeout(() => {
                        this.getOrder(next);
                    }, 1000);
                }
            });
        },
        submit() {
            if (this.orderId) {
                return;
            }
            this.$http
                .post('/user/verifyTradeCode', {
                    tradeCode: this.password
                })
                .then(() => {
                    this.$http
                        .post('/asset/gift', {
                            assetId: this.$route.query.id,
                            toUserId: this.$route.query.toUserId
                        })
                        .then(res => {
                            this.orderId = res.id;
                            this.$nextTick(() => {
                                if (this.payType === 'ALIPAY') {
                                    // document.location.replace(
                                    //     resolveUrl(this.$baseUrl, 'payOrder/gift/alipay?id=' + res.id)
                                    // );
                                    this.$http
                                        .get(`/payOrder/gift/${this.inApp ? 'alipay_app' : 'alipay_h5'}?id=${res.id}`)
                                        .then(res => {
                                            this.hrefUrl = 'alipays://platformapi/startapp?saId=10000007&qrcode=' + res;
                                            // window.open(
                                            //     'alipays://platformapi/startapp?saId=10000007&qrcode=' + res,
                                            //     '_blank'
                                            // );
                                            this.$nextTick(() => {
                                                document.getElementById('pay').click();
                                            });

                                            this.$toast.loading({
                                                message: '加载中...',
                                                forbidClick: true
                                            });
                                            this.getOrder(true);
                                        })
                                        .catch(e => {
                                            if (e.error) {
                                                this.$toast(e.error);
                                            }
                                        });
                                } else if (this.payType === 'WEIXIN') {
                                    if (this.inWeixin) {
                                        this.$toast.loading('加载中');
                                        this.$http
                                            .post('/payOrder/gift/weixin', {
                                                id: res.id,
                                                openId: localStorage.getItem('openId')
                                            })
                                            .then(res => {
                                                console.log({
                                                    ...res,
                                                    package: res.package || res.packageValue,
                                                    timestamp: res.timestamp || res.timeStamp
                                                });
                                                let _this = this;
                                                wx.chooseWXPay({
                                                    ...res,
                                                    package: res.package || res.packageValue,
                                                    timestamp: res.timeStamp,
                                                    success(res) {
                                                        _this.$toast.success('支付成功');
                                                        setTimeout(() => {
                                                            _this.$router.replace('/orders');
                                                        }, 1000);
                                                    },
                                                    fail(e) {
                                                        console.log(e);
                                                        _this.$toast('支付失败，请稍后再试');
                                                    }
                                                });
                                            });
                                    } else {
                                        document.location.replace(
                                            resolveUrl(this.$baseUrl, 'payOrder/gift/weixin_h5?id=' + res.id)
                                        );
                                    }
                                }
                            });
                        })
                        .catch(e => {
                            if (e) {
                                this.$toast(e.error);
                            }
                        });
                })
                .catch(e => {
                    if (e) {
                        this.$toast('失败点击忘记密码进行修改');
                    }
                });
        }
    },
    beforeUnmount() {
        if (this.timer) {
            clearTimeout(this.timer);
            this.timer = null;
        }
    }
};
</script>

<style lang="less" scoped>
.submit {
    padding: 0 0 20px;
    background-color: @bg3;
}
.page-top {
    padding: 20px 16px 0;
    background-color: @bg;
}

.pageTitle {
    font-size: 14px;
    color: @text0;
    line-height: 22px;
}
.input {
    padding: 20px 16px;
    background-color: @bg;
    .text1 {
        font-size: 14px;
        color: @text0;
        line-height: 24px;
        margin-bottom: 6px;
        text-align: center;
    }
    .text2 {
        font-size: 14px;
        text-align: right;
        font-weight: 400;
        color: @text3;
        line-height: 24px;
        margin-right: 15px;
    }

    .text3 {
        font-size: @font2;
        color: #ff4f50;
        line-height: 24px;
        margin-top: 25px;
        display: flex;
        justify-content: center;
    }
}

/deep/ .van-password-input {
    margin: 0 0;
    .van-password-input__security {
        border: 1px solid @text3;
        height: 42px;
        border-radius: 2px;
        li {
            background-color: transparent;
            &:not(:last-child) {
                border-right: 1px solid @text3;
            }
            i {
                color: @text0;
            }
        }
    }
}
/deep/.van-number-keyboard__body {
    background-color: fade(#4a4a4a, 50%);
    .van-key {
        background-color: @bg;
        &:active {
            background-color: @bg3;
        }
    }
}
.list {
    padding: 0 16px;
    background-color: @bg;
}
.info {
    display: flex;
    align-items: center;
    justify-content: space-between;
    height: 60px;
    border-bottom: 1px solid @tabBorder;
    .text1 {
        font-size: 14px;
        color: @text0;
        line-height: 24px;
    }

    .text2 {
        font-size: 16px;
        font-weight: bold;
        color: @prim;
        line-height: 24px;
    }

    .text3 {
        font-size: 14px;
        color: @text3;
        line-height: 20px;
    }
}
/deep/ .van-password-input {
    margin: 10px 0;
    padding: 0 25px;
    .van-password-input__security {
        border: 1px solid @text3;
        height: 42px;
        border-radius: 2px;
        li {
            background-color: transparent;
            &:not(:last-child) {
                border-right: 1px solid @text3;
            }
            i {
                color: @text0;
            }
        }
    }
}
.product {
    display: flex;
    padding: 12px 0 20px;
    .product-content {
        flex-grow: 1;
        margin-left: 10px;
        display: flex;
        flex-direction: column;
        .no {
            flex-grow: 1;
            padding: 4px 0 8px;
            font-size: 14px;
            color: @text3;
            line-height: 24px;
        }
        .text {
            font-size: 14px;
            color: @text3;
            line-height: 24px;
            margin-top: 4px;
        }
        .text1 {
            font-size: @font2;
            color: @text0;
            line-height: 24px;
        }
        .text3 {
            font-size: @font2;
            font-weight: 400;
            color: #b81c22;
            line-height: 24px;
            margin-top: 40px;
            display: flex;
            justify-content: center;
        }
        .price {
            font-size: 16px;
            font-weight: bold;
            color: @text0;
            line-height: 24px;
        }
    }
}

/deep/.van-field {
    padding: 20px 0;
    .van-field__label {
        font-size: 14px;
        color: @text0;
        line-height: 24px;
    }
    .van-field__control {
        text-align: right;
        color: @text3;
    }
}

.pay-item {
    display: flex;
    align-items: center;
    height: 60px;
    // border-top: 1px solid #202122;
    span {
        font-size: 14px;
        font-weight: bold;
        color: @text0;
        line-height: 24px;
        flex-grow: 1;
        padding: 0 10px;
    }

    .choose {
        width: 24px;
        height: 24px;
    }
}

.bottom {
    position: fixed;
    bottom: 0px;
    left: 0;
    right: 0;
    background-color: @bg;
    z-index: 20;
    border-top: 1px solid @tabBorder;

    .bottom-content {
        padding: 6px 16px;
        display: flex;
        align-items: center;
        justify-content: space-between;

        .btn1 {
            width: 161px;
            height: 44px;
            border-radius: 22px;
            line-height: 44px;
            color: @text3;
            text-align: center;
            border: 1px solid @text3;
        }
        .btn2 {
            width: 162px;
            height: 44px;
            line-height: 44px;
            text-align: center;

            color: @btnText;
            background: linear-gradient(135deg, @prim 0%, @prim 100%);
            border-radius: 22px;
        }
        .van-button {
            flex-grow: 1;
            color: #333230 !important;
            max-width: 210px;
        }
        .text {
            font-size: 14px;
            color: @text3;
            line-height: 20px;
            word-break: keep-all;
        }

        .price {
            font-size: 34px;
            font-family: OSP;
            font-weight: normal;
            color: @prim;
            line-height: 34px;
            // flex-grow: 1;
            margin: 0 10px;
            .font_family {
                font-size: 10px;
            }
        }
    }
}
</style>
